unit EditMSG;

interface

uses
  Windows, Messages, SysUtils, Forms, Dialogs, Controls, Classes, ExtCtrls,
  Menus, ImgList, ComCtrls, StdCtrls, Grids, Buttons, ToolWin, ActnList,
  Spin;

type
  TStat = record
    Left, Top, Width, Height: Integer;
    Max: Boolean;
  end;
  TPrgOpt = record
    RunLastFile: Boolean;
    AddNumComm: Integer;
    RunScriptMsg: Boolean;
    MsgPath: array of string;
    SetCod1C: Boolean;
  end;

type
  TfrmEditMsg = class(TForm)
    tlbrMain: TToolBar;
    tlbtnNewMSG: TToolButton;
    tlbtnLoadMSG: TToolButton;
    tlbtnSaveMSG: TToolButton;
    imglstBtnIcons: TImageList;
    grdMSG: TStringGrid;
    rcdtTempMSG: TRichEdit;
    tlbtnSeparator1: TToolButton;
    opndlgOpenMSG: TOpenDialog;
    svdlgSaveMSG: TSaveDialog;
    tlbtnSaveAs: TToolButton;
    stsbrMain: TStatusBar;
    tlbtnAddComment: TToolButton;
    tlbtnAddNum: TToolButton;
    tlbtnDelStr: TToolButton;
    tlbtnSeparator3: TToolButton;
    tlbtnAddClearDown: TToolButton;
    tlbtnSeparator2: TToolButton;
    tlbtnGoConstr: TToolButton;
    tlbtnSeparatorAbout: TToolButton;
    pmnHistory: TPopupMenu;
    spdbtnAbout: TSpeedButton;
    tlbtnPrgOpt: TToolButton;
    tlbtnSeparator4: TToolButton;
    tlbtnAddClear: TToolButton;
    edtWndMsg: TEdit;
    tmrMainPanel: TTimer;
    edtFind: TEdit;
    tlbtnGoBegin: TToolButton;
    tlbtnSeparator6: TToolButton;
    tlbtnGoEnd: TToolButton;
    tlbtnSeparator7: TToolButton;
    tlbtnFindDown: TToolButton;
    tlbtnFindUp: TToolButton;
    tlbtnSeparator8: TToolButton;
    tlbtnMoveRange: TToolButton;
    tlbtnSeparator5: TToolButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure tlbtnLoadMSGClick(Sender: TObject);
    procedure tlbtnSaveMSGClick(Sender: TObject);
    procedure tlbtnNewMSGClick(Sender: TObject);
    procedure tlbtnSaveAsClick(Sender: TObject);
    procedure WndProc(var Msg : TMessage); Override;
    procedure tlbtnAddCommentClick(Sender: TObject);
    procedure tlbtnDelStrClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure tlbtnAddNumClick(Sender: TObject);
    procedure grdMSGKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure tlbtnAddClearDownClick(Sender: TObject);
    procedure tlbtnGoConstrClick(Sender: TObject);
    procedure grdMSGKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure grdMSGGetEditText(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure grdMSGKeyPress(Sender: TObject; var Key: Char);
    procedure itmHistoryClick(Sender: TObject);
    procedure spdbtnAboutClick(Sender: TObject);
    procedure tlbrMainResize(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure tlbtnPrgOptClick(Sender: TObject);
    procedure tlbtnAddClearClick(Sender: TObject);
    procedure grdMSGSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure edtWndMsgChange(Sender: TObject);
    procedure stsbrMainMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure tmrMainPanelTimer(Sender: TObject);
    procedure tlbtnGoBeginClick(Sender: TObject);
    procedure tlbtnGoEndClick(Sender: TObject);
    procedure tlbtnFindDownClick(Sender: TObject);
    procedure tlbtnFindUpClick(Sender: TObject);
    procedure grdMSGMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure tlbtnMoveRangeClick(Sender: TObject);
    procedure grdMSGMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private { Private declarations }
    procedure LoadedMSG(const AFullName: string);
    procedure SavedMSG(const AFullName: string);
    procedure GridMSGInitial;
    function Izmenenia(Sender: TObject): Boolean;
    procedure SaveNewMSG;
    function NumFindMSG(const ANum: Integer; var ANumStr: Integer): String;
    function CheckClearString(ANum: Word): Boolean;
    procedure AddNumerToEnd;
    procedure AddNumerToNext;
    function InitCommandLine(Sender: TObject): Boolean;
    procedure AddNewMnuItemToBegin(const ANameProg: string;
      APopup: TPopupMenu);
    procedure AddPostStr;
    function FindMsgInPath(const AName: String): String;
    function FindTextInMSG(const AStr: string; ToDown: Boolean): Boolean;
    procedure RestoreAfterMoveRange;
    procedure ReNomerationMSG(const ATop, ABottom, AInc: Integer);
  public
    { Public declarations }
    procedure MoveGridRange(AGrid: TStringGrid; ATop, ABottom, ANewTop: Integer);
    function NomerRepeateControl(Nom: Integer): Boolean;
  end;

const
  CR = #13#10;
  WM_EditMSG = WM_USER + 10888; //   EditorMSG
  AppName = 'EditorMSG';
  CNameDefault = 'noname.msg';
  CNameProgr = ' msg-';
  NameConstrScript = ' ';
  ASizeMnuHistory = 25; //      
  SizeMsgPath = 10; //     msg-

var
  frmEditMsg: TfrmEditMsg;
  StatEditMsg: TStat; //     
  AFileName: string;
  ASelfPath: string; //     
  edtHand: HWND = 0;
  Hand: HWND;
  AStrEsc: string; //      ESC
  PrgOpt: TPrgOpt; //   
  FlagMoveRange: Boolean = False; //    
  mr: TGridRect; //   
  //ANewLine: Integer; //       
  Cod1C: Boolean = False; //   1 ()
  

implementation

uses WorkINI, MathPNO, untAboutBox, untPrgOpt, untMoveRange;

var DLine: TDLine;

{$R *.DFM}

procedure TfrmEditMsg.WndProc(var msg : TMessage);
//   
var
  TempStr: string;
  ANumStr: Integer;
  HandFgeckForm: HWND;
begin
  with msg do
    if (msg = WM_EditMSG) then
      case wParam of
        2 : edtHand := lParam; //  HWND 
        3 : begin //   ,    
              TempStr := IntToStr(lParam) + '<m>' + NumFindMSG(lParam, ANumStr);
              SendMessage(edtHand, WM_Settext, 0, Integer(TempStr));
            end;
        4 : with grdMSG do
            begin
              SetFocus;
              if not Focused then Exit;
              //if (frmEditMsg.WindowState<>wsMinimized) then
              Application.Restore; //    XP
              if lParam=0 then AddNumerToEnd //   , 
              else
              begin
                NumFindMSG(lParam, ANumStr);
                if ANumStr<>0 then
                begin
                  Row := ANumStr;
                  Col := 2;
                  edtFind.SetFocus;
                end;
              end;
            end;
        5 : begin //    HWND 
              HandFgeckForm := lParam;
              PostMessage(HandFgeckForm, WM_EditMSG, 6, edtWndMsg.Handle);
              //ShowMessage('   HWND ');
            end;
      end;
  inherited;
end;

function EnumProc(Wd: HWnd; Param: LongInt): Boolean; stdcall;//  stdcall !!!
var
  Nm: array[0..255] of Char;  //    
begin //     
  Hand := 0;
  GetWindowText(Wd, Nm, 255); //     
  if Pos(NameConstrScript, String(Nm))<>0 then
  begin
    EnumProc := False;
    Hand := Wd;
  end
  else EnumProc := True;
end;

procedure TfrmEditMsg.FormClose(Sender: TObject; var Action: TCloseAction);
begin //    
  SavePathsToINI; //   
  //     
  if WindowState = wsMaximized then StatEditMsg.Max := True
  else
  begin
    StatEditMsg.Max := False;
    StatEditMsg.Left := Left;
    StatEditMsg.Top := Top;
    StatEditMsg.Width := Width;
    StatEditMsg.Height := Height;
  end;
  SaveFormStatToINI;
  SavePrgOptToINI;
end;

function TfrmEditMsg.InitCommandLine(Sender: TObject): Boolean;
var
  i: Integer;
  AStr, AExt: string;
begin // *** Command Line * * *   ***
  Result := False;
  AStr := '';
  for i:=1 to ParamCount do AStr := AStr + ParamStr(i) + ' ';
  Delete(AStr, Length(AStr), 1); //  ""  
  if LowerCase(ExtractFileExt(AStr))='.msg' then
    if FileExists(AStr) then
    begin
      AFileName :=AStr;
      try
        LoadedMSG(AFileName);
        AddNewMnuItemToBegin(AFileName, pmnHistory);
        tlbtnSaveMSG.Enabled := False;
        Caption := CNameProgr + ' - [' + ExtractFileName(AFileName) + ']';
        Application.Title := '[' + ExtractFileName(AFileName) + '] ' + AppName;
        Result := True;
      except
        ShowMessage(' :       InitCommandLine.');
        frmEditMsg.Enabled := True; //  
        AFileName := CNameDefault; //    noname
      end;
    end;
  AExt := LowerCase(ExtractFileExt(AStr));
  if PrgOpt.RunScriptMsg and ((AExt='.ssl') or (AExt='.int') or (AExt='.ipp')) then
    edtWndMsg.Text := ExtractFileName(AStr);
end;

procedure TfrmEditMsg.GridMSGInitial;
begin //   
  grdMSG.EditorMode := False;
  grdMSG.SetFocus;
  grdMSG.Cols[0].Clear;
  grdMSG.Cols[1].Clear;
  grdMSG.Cols[2].Clear;
  grdMSG.RowCount := 2;
  grdMSG.Cells[0,0] := '';
  // grdMSG.Cells[1,0] := '  ';
  grdMSG.Cells[2,0] := '   ';
end;

procedure TfrmEditMsg.tlbtnLoadMSGClick(Sender: TObject);
var ATmpName, AExt: String;
begin //   ""
  grdMSG.EditorMode := False;
  if Izmenenia(Sender) then
  begin
    if opndlgOpenMSG.Execute then
    begin
      //GridMSGInitial; //    
      ATmpName := opndlgOpenMSG.FileName;
      AExt := LowerCase(ExtractFileExt(ATmpName));
      if PrgOpt.RunScriptMsg and ((AExt='.ssl') or (AExt='.int') or (AExt='.ipp')) then
      begin
        edtWndMsg.Text := ExtractFileName(ATmpName);
        Exit;
      end;
      if AExt<>'.msg' then Exit;
      AFileName := ATmpName;
      try
        LoadedMSG(AFileName);
        AddNewMnuItemToBegin(AFileName, pmnHistory);
        tlbtnSaveMSG.Enabled := False;
        Caption := CNameProgr + ' - [' + ExtractFileName(AFileName) + ']';
        Application.Title := '[' + ExtractFileName(AFileName) + '] ' + AppName;
        grdMSG.SetFocus;
        opndlgOpenMSG.InitialDir := ExtractFilePath(AFileName);
      except
        ShowMessage(' :       tlbtnLoadMSGClick.');
        frmEditMsg.Enabled := True; //  
        AFileName := CNameDefault; //    noname
      end;
    end;
  end;
end;

procedure TfrmEditMsg.LoadedMSG(const AFullName: string);
var
  nl: Longint; //   
  AStr: string;
  a: TScobPos;
begin //      
  GridMSGInitial; //     
  frmEditMsg.Enabled := False; //     
  grdMSG.Visible := False; //     
  rcdtTempMSG.Lines.LoadFromFile(AFullName);
  //   
  Cod1C := (GetTypeCodeText(rcdtTempMSG.Text)=win) or
           ((GetTypeCodeText(rcdtTempMSG.Text)=ukn) and (PrgOpt.SetCod1C));
  //  Cod1C  ,     Win, 
  //    ,      1
  //if Cod1C then ShowMessage('1C True') else ShowMessage('1C False');
  for nl:=0 to rcdtTempMSG.Lines.Count-1 do
  begin
    Application.ProcessMessages();
    if rcdtTempMSG.Lines[nl]='' then Continue; //    
    if not(Cod1C) then AStr := StrDosToWinSpec(rcdtTempMSG.Lines[nl], a)
    else AStr := Str1CSpec(rcdtTempMSG.Lines[nl], a); //   1
    //AStr := StrDosToWinSpec(rcdtTempMSG.Lines[nl], a);
    with grdMSG do
    begin
      if AStr[1]='#' then //  
      begin
        Cells[0,RowCount-1] := '#';
        Cells[2,RowCount-1] := Copy(AStr, 2, Length(AStr)-2);
        RowCount := RowCount + 1;
        Continue;
      end;
      if (a[0,1]=3) and (a[0,2]=3) then
      begin
        Cells[0,RowCount-1] := Copy(AStr, a[1,1]+1, a[1,2]-a[1,1]-1);
        Cells[1,RowCount-1] := Copy(AStr, a[2,1]+1, a[2,2]-a[2,1]-1);
        Cells[2,RowCount-1] := Copy(AStr, a[3,1]+1, a[3,2]-a[3,1]-1);
      end
      else
        if (a[0,1]=3) and (a[0,2]=2) then
        begin
          Cells[0,RowCount-1] := Copy(AStr, a[1,1]+1, a[1,2]-a[1,1]-1);
          Cells[1,RowCount-1] := Copy(AStr, a[2,1]+1, a[2,2]-a[2,1]-1);
          Cells[2,RowCount-1] := Copy(AStr, a[3,1]+1, Length(AStr)-a[3,1]-1);
        end
        else
          if (a[0,1]=0) and (a[0,2]=1) then
            Cells[2,RowCount-1] := Copy(AStr, 1, a[1,2]-1)
          else if (a[0,1]=0) and (a[0,2]=0) then
                 Cells[2,RowCount-1] := Copy(AStr, 1, Length(AStr)-1);
      RowCount := RowCount + 1;
    end; 
  end;
  rcdtTempMSG.Lines.Clear;
  grdMSG.Visible := True;
  frmEditMsg.Enabled := True;
  grdMSG.SetFocus;
  stsbrMain.Panels[0].Text := AFullName;
end;

procedure TfrmEditMsg.SavedMSG(const AFullName: string);
var
  nl: Longint; //   
  AStr: string;
  ATmp: TMemoryStream;
begin //    
  ATmp := TMemoryStream.Create;
  try
    with grdMSG, rcdtTempMSG do
      for nl:=1 to RowCount do
      begin
        Application.ProcessMessages();
        if (Cells[0, nl]='') and (Cells[1, nl]='') and
           (Cells[2, nl]='') then Continue; //    
        
        if not PrgOpt.SetCod1C then Cells[2, nl] := StringReplace(Cells[2, nl], '', 'X', [rfReplaceAll]); //     
        
        if Cells[0, nl]='#' then
        begin //  
          AStr := '#'+StrWinToDos(Cells[2, nl], PrgOpt.SetCod1C)+CR;
          //if not(Cod1C) then AStr := '#'+StrWinToDos(Cells[2, nl])+CR
          //else AStr := '#'+Cells[2, nl]+CR //   1
          ATmp.WriteBuffer(pointer(AStr)^, Length(AStr));
          Continue;
        end;
        if (Cells[0, nl]<>'') then
        begin //   ()
          if (RowCount=nl) then
          begin //    - 
            AStr := '{'+Cells[0, nl]+'}{'+Cells[1, nl]+'}{'+StrWinToDos(Cells[2, nl], PrgOpt.SetCod1C)+'}'+CR;
            ATmp.WriteBuffer(pointer(AStr)^, Length(AStr));
            Continue;
          end;
          if ((Cells[0, nl+1]='') and (Cells[1, nl+1]='') and
           (Cells[2, nl+1]='')) or (Cells[0, nl+1]<>'') then
          begin //    ,   
            AStr := '{'+Cells[0, nl]+'}{'+Cells[1, nl]+'}{'+StrWinToDos(Cells[2, nl], PrgOpt.SetCod1C)+'}'+CR;
            ATmp.WriteBuffer(pointer(AStr)^, Length(AStr));
            Continue;
          end;
          //   '}'  
          AStr := '{'+Cells[0, nl]+'}{'+Cells[1, nl]+'}{'+StrWinToDos(Cells[2, nl], PrgOpt.SetCod1C)+CR;
          ATmp.WriteBuffer(pointer(AStr)^, Length(AStr));
          Continue;
        end;
        if (Cells[0, nl]='') and (Cells[1, nl]='') then
        begin //     
          if (RowCount=nl) then
          begin //   
            AStr := StrWinToDos(Cells[2, nl]+'}', PrgOpt.SetCod1C)+CR;
            ATmp.WriteBuffer(pointer(AStr)^, Length(AStr));
            Continue;
          end;
          if ((Cells[0, nl+1]='') and (Cells[1, nl+1]='') and
           (Cells[2, nl+1]='')) or (Cells[0, nl+1]<>'') then
          begin //    ,   
            AStr := StrWinToDos(Cells[2, nl]+'}', PrgOpt.SetCod1C)+CR;
            ATmp.WriteBuffer(pointer(AStr)^, Length(AStr));
            Continue;
          end;
          //   '}'  
          AStr := StrWinToDos(Cells[2, nl], PrgOpt.SetCod1C)+CR;
          ATmp.WriteBuffer(pointer(AStr)^, Length(AStr));
          Continue;
        end;
      end;
//    for i:=1 to Length(ATmp.) do
//     if str[i]='' then str[i]:='0';
    ATmp.SaveToFile(AFullName);
  finally
    ATmp.Free;
  end;
end;

procedure TfrmEditMsg.tlbtnSaveMSGClick(Sender: TObject);
begin  //   
  grdMSG.EditorMode := False;
  if AFileName = CNameDefault then SaveNewMSG
  else
  begin
    if ExtractFileExt(AFileName)='' then
      AFileName:=ChangeFileExt(AFileName,'.msg');
    SavedMSG(AFileName);
    tlbtnSaveMSG.Enabled := False; //    (..  )
  end;
end;

procedure TfrmEditMsg.SaveNewMSG;
begin //        
  svdlgSaveMSG.FileName := ExtractFileName(AFileName);
  //svdlgSaveMSG.InitialDir := ExtractFilePath(AFileName);
  if svdlgSaveMSG.Execute then
  begin
    AFileName := svdlgSaveMSG.FileName;
    if ExtractFileExt(AFileName)='' then AFileName:=ChangeFileExt(AFileName,'.msg');
    Caption := CNameProgr + ' - [' + ExtractFileName(AFileName) + ']';
    Application.Title := '[' + ExtractFileName(AFileName) + '] ' + AppName;
    SavedMSG(AFileName);
    svdlgSaveMSG.InitialDir := ExtractFilePath(AFileName);
    AddNewMnuItemToBegin(AFileName, pmnHistory);
    tlbtnSaveMSG.Enabled := False; //    (..  )
  end;
end;

procedure TfrmEditMsg.tlbtnNewMSGClick(Sender: TObject);
begin //   
  if Izmenenia(Sender) then
  begin
    AFileName := CNameDefault;
    Caption := CNameProgr + ' - [' + ExtractFileName(AFileName) + ']';
    Application.Title := '[' + ExtractFileName(AFileName) + '] ' + AppName;
    tlbtnSaveMSG.Enabled := False;
    GridMSGInitial;
  end;
end;
(*
procedure TfrmMain.tlbtnNewClick(Sender: TObject);
begin //     
  if Izmenenia(Sender) then
  begin
    AFileName := CNameDefault;
    frmMain.Caption := CNameProgr + ' - [' + ExtractFileName(AFileName) + ']';
    CreateNewScript(Sender);
  end;
end;

procedure TfrmMain.CreateNewMSG(Sender: TObject);
var i: Word;
begin //   
  SetFocusTekMemo(Sender);
  NormCurAndCol(Sender);  //      
  with pgcntrlMain do
    for i:=PageCount-1 downto 1 do Pages[i].Free;
  mInitial.ClearAll; //.Clear
  AModif := False;
  tlbtnSave.Enabled := AModif;
  PrUIN := 0;
  CloseOldTS;
end;
*)

function TfrmEditMsg.Izmenenia(Sender: TObject): Boolean;
var
  APress: Word;
begin //  -   
  Result := True;
  if tlbtnSaveMSG.Enabled then
  begin
    //Result := False;
    APress := MessageBox(Application.Handle,
      PChar(' "' + ExtractFileName(AFileName) + '"  .  ?'),
      PChar(' msg-'), MB_ICONWARNING + MB_YESNOCANCEL);
      case APress of
        6:        tlbtnSaveMSGClick(Sender); //         //SaveNewScript(Sender);
        7:        Result := True; //   
        2:        Result := False; //  
      else        ShowMessage(' :     -     !!!');
    end;
  end;
end;


procedure TfrmEditMsg.tlbtnSaveAsClick(Sender: TObject);
begin //   " ..."
  grdMSG.EditorMode := False;
  SaveNewMSG;
  //AddNewMnuItemToBegin(AFileName, pmnHistory);
end;

function TfrmEditMsg.NumFindMSG(const ANum: Integer; var ANumStr: Integer): String;
var
  i: Word;
  nsf: Boolean; // , ,   
begin //       (,   )
  Result := '';
  nsf := False;
  for i:=1 to grdMSG.RowCount-1 do
    with grdMSG do
    begin
      if Cells[0,i]=IntToStr(ANum) then
      begin
        ANumStr := i;
        Result := Cells[2,i];
        nsf := True;
        Continue;
      end;
      if nsf then //     
      begin
        if (Cells[0,i]<>'') or (Cells[2,i]='') then Exit //  
        else Result := Result + '<cr>' + Cells[2,i]; //  
      end;
    end;
end;

procedure TfrmEditMsg.tlbtnAddCommentClick(Sender: TObject);
begin //    
  tlbtnSaveMSG.Enabled := True;
  with grdMSG do
  begin
    if not(CheckClearString(Row)) then tlbtnAddClearDownClick(Sender);
    if (Row=RowCount-1) and (Row<>1) then //   (    )
    begin
      Row := Row - 1;
      tlbtnAddClearDownClick(Sender);
    end;
    Cells[0, Row] := '#';
    Col := 2;
    EditorMode := True;
  end;
end;

procedure TfrmEditMsg.tlbtnDelStrClick(Sender: TObject);
var i: Word;
begin //    
  tlbtnSaveMSG.Enabled := True;
  with grdMSG do
  begin
    for i:=Row+1 to RowCount do Rows[i-1] := Rows[i];
    if RowCount>2 then RowCount := RowCount - 1;
    if not(CheckClearString(RowCount-1)) then
    begin //     ,    
      RowCount := RowCount + 1;
      Row := RowCount - 1;
    end;
  end;
end;

procedure TfrmEditMsg.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin //    ,   
  CanClose := Izmenenia(Sender); //     ""
end;

procedure TfrmEditMsg.tlbtnAddNumClick(Sender: TObject);
begin //      
  with grdMSG do
  begin
    //if Row<>RowCount-1 then tlbtnAddClearDownClick(nil); //     
    AddNumerToNext;
    if (Row=RowCount-1) and not(CheckClearString(Row)) then RowCount:=RowCount+1; //    
  end;
{  with grdMSG do
  begin
    if (Row=RowCount-1) then AddNumerToEnd //    
    else //   
    begin
      tlbtnAddClearDownClick(Sender);
      AddNumerToNext;
    end;
  end;  }
end;

function TfrmEditMsg.NomerRepeateControl(Nom: Integer): Boolean;
var i, ANumMSG, AErr: Integer;
begin //     ,  True,    
  Result := True;
  with grdMSG do
    for i:=1 to RowCount do
    begin
      Val(Cells[0, i], ANumMSG, AErr);
      if AErr<>0 then Continue;
      Result := Nom<>ANumMSG;
      if not Result then Exit;
    end;
end;

procedure TfrmEditMsg.AddNumerToNext;
var
  ANumMSG, AErr, i, Tmp: Integer;
  CommFlg: Boolean; //   
begin //      
  CommFlg := False;
  with grdMSG do
  begin
    if not(CheckClearString(RowCount-1)) then RowCount := RowCount + 1;
    for i:=Row downto 1 do //    
    begin
      if not(CommFlg) then CommFlg := Cells[0, i]='#'; //   
      Val(Cells[0, i], ANumMSG, AErr);
      if AErr<>0 then Continue; //  
      tlbtnSaveMSG.Enabled := True;
      if not(CommFlg) or (PrgOpt.AddNumComm=0) then //   .   .  .
        ANumMSG := ANumMSG + 1 //Cells[0, Row]:=IntToStr(ANumMSG+1)
      else
      begin
        if Length(IntToStr(PrgOpt.AddNumComm))=2 then Tmp := 10 else Tmp := 100;
        ANumMSG := ((ANumMSG+5) div Tmp)*Tmp+PrgOpt.AddNumComm;
        //Cells[0, Row]:=IntToStr(((ANumMSG+5) div Tmp)*Tmp+PrgOpt.AddNumComm);
      end;
      //Col := 0;
      if NomerRepeateControl(ANumMSG) then //      
      begin
        if not CheckClearString(Row) then tlbtnAddClearDownClick(nil); //       
        Cells[0, Row] := IntToStr(ANumMSG);
        Col := 2;
        SetFocus;
        grdMSG.EditorMode := True;
      end
      else
      begin
        //tlbtnDelStrClick(nil); //    
        //Row := Row - 1;
        stsbrMain.Panels[0].text := '   '+IntToStr(ANumMSG)+'  '; // ShowMessage('  ');
        MessageBeep(MB_ICONEXCLAMATION);
      end;

      Exit;
    end;
    //Col := 0;
    //Beep;
    {
    if RowCount>2 then
    begin
      tlbtnDelStrClick(nil); //    
      Row := Row - 1;
    end;   }
    //stsbrMain.Panels[0].text := '   '; // ShowMessage('  ');
    MessageBeep(MB_ICONEXCLAMATION);
  end;
end;

procedure TfrmEditMsg.AddNumerToEnd;
var
  ANumMSG, AErr, i, Tmp: Integer;
  CommFlg: Boolean; //   
begin //      
  CommFlg := False;
  with grdMSG do
  begin
    if not(CheckClearString(RowCount-1)) then RowCount := RowCount + 1;
    for i := RowCount-2 downto 1 do
    begin
      if not(CommFlg) then CommFlg := Cells[0, i]='#'; //   
      Val(Cells[0, i], ANumMSG, AErr);
      if AErr=0 then
      begin
        tlbtnSaveMSG.Enabled := True;
        if not(CommFlg) or (PrgOpt.AddNumComm=0) then //   .   .  .
          Cells[0, RowCount-1]:=IntToStr(ANumMSG+1)
        else
        begin
          if Length(IntToStr(PrgOpt.AddNumComm))=2 then Tmp := 10 else Tmp := 100;
          Cells[0, RowCount-1]:=IntToStr(((ANumMSG+5) div Tmp)*Tmp+PrgOpt.AddNumComm);
        end;
        SetFocus;
        Row := RowCount - 1;
        Col := 2;
        RowCount := RowCount + 1;
        grdMSG.EditorMode := True;
        Exit;
      end;
    end;
    Row := RowCount-1;
    Col := 0;
    //Beep;
    MessageBeep(MB_ICONEXCLAMATION);
  end;
end;

function TfrmEditMsg.CheckClearString(ANum: Word):Boolean;
begin //  True,    
  Result := False;
  with grdMSG do
    if (Cells[0, ANum]='') and (Cells[1, ANum]='') and
       (Cells[2, ANum]='') then Result := True;
end;

(*
procedure TfrmEditMsg.DelClearStrInEnd;
var i: Integer;
begin //      

end;
*)

procedure TfrmEditMsg.grdMSGKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var TmpVal: Integer;
begin
  if (key=VK_ESCAPE) and  tlbtnMoveRange.Enabled then RestoreAfterMoveRange;
  if not(tlbrMain.Enabled) then Exit; //    ,    
  with grdMSG do
  begin

    if (ssCtrl in Shift) and (Key=75) then // "Ctrl+K" //   dec  hex
    begin
      if Col=2 then
      begin
        TmpVal :=StrToIntDef(Cells[Col, Row], -1);
        if TmpVal<>-1 then
        begin
          Cells[Col, Row] := IntToHex(TmpVal, 8);
          tlbtnSaveMSG.Enabled := True;
          if Row<>RowCount-1 then Row := Row + 1; //    
        end;
      end;
    end;
    if (ssCtrl in Shift) and (Key=76) then // "Ctrl+L" //    hex  dec
    begin
      if Col=2 then
      try
        Cells[Col, Row] := IntToStr(StrToInt('$'+Cells[Col, Row]));
        tlbtnSaveMSG.Enabled := True;
        if Row<>RowCount-1 then Row := Row + 1; //    
      except
      end;


        //TmpVal :=StrToIntDef(Cells[Col, Row], -1);
        {
        val('$'+Cells[Col, Row], TmpVal, Err);
        if TmpVal=0 then
        begin
          Cells[Col, Row] := IntToStr(TmpVal);
          tlbtnSaveMSG.Enabled := True;
          if Row<>RowCount-1 then Row := Row + 1; //    
        end;   }

    end;

      //if (key=VK_TAB) and EditorMode and (Col=2) and (Row=RowCount-1) then
    //  Col:=1;//ShowMessage('sfsf');
    //if key=VK_F2 then grdMSG.EditorMode := False; //    
    if (key=Ord('3')) and (ssCtrl in Shift) then tlbtnAddCommentClick(Sender);
    if (key=VK_LEFT) and EditorMode and (Col=2) and (Cells[Col, Row] = '') then Col := 0;
    if key=VK_F3 then tlbtnGoConstrClick(Sender); //  F3 (   )
    if key=VK_RETURN then //  Enter
    begin
      if (ssAlt in Shift) then
      // if (ssCtrl in Shift) then // Ctrl         
      begin // Alt+Enter
        //key := 0;
        tlbtnAddNumClick(Sender); //     
        exit;
      end;
      with grdMSG do
        if (Row=RowCount-1) or ((RowCount>2) and (Row=RowCount-2) and
          CheckClearString(RowCount-1)) then AddPostStr //     
        else
        if EditorMode then
        begin
          tlbtnAddClearDownClick(Sender);
          //Row := Row + 1; // ,  
          Col := 2;
          //EditorMode := True; // ,    - 
        end;
    end;
  end;
end;

procedure TfrmEditMsg.AddPostStr;
begin //         ,  
  tlbtnSaveMSG.Enabled := True;
  with grdMSG do
  begin
    RowCount := RowCount + 1;
    Row := Row + 1; // ,  
    Col := 2;
    //EditorMode := True; //  
  end;
end;

procedure TfrmEditMsg.tlbtnAddClearDownClick(Sender: TObject);
var i: Word;
begin //   ,  
  tlbtnSaveMSG.Enabled := True;
  with grdMSG do
  begin
    RowCount := RowCount + 1;
    for i:=RowCount-1 downto Row+1 do Rows[i] := Rows[i-1];
    Rows[Row+1].Clear;
    Row := Row + 1;
    Col := 0;
  end;
end;

procedure TfrmEditMsg.tlbtnGoConstrClick(Sender: TObject);
var ANumMSG, AErr: Integer;
begin //         5
  if tlbtnSaveMSG.Enabled then tlbtnSaveMSGClick(Sender); //  
  EnumWindows(@EnumProc, 0); //     
  if Hand<>0 then
  begin
    //SetForeGroundWindow(Hand); //     ,  
    //BringWindowToTop(Hand);
    //SetActiveWindow(Hand);
    //ShowWindow(Hand, SW_SHOWNA);
    //Windows.SetFocus(Hand);
    //SendMessage(Hand, BM_CLICK, 0, 0);
    SetForeGroundWindow(GetWindowLong(Hand, GWL_HWNDPARENT)); //  
    //if GetForegroundWindow<>GetWindowLong(Hand, GWL_HWNDPARENT) then Exit; //  ,  
    Val(grdMSG.Cells[0, grdMSG.Row], ANumMSG, AErr);
    //if AErr=0 then SendMessage(Hand, WM_EditMSG, 5, ANumMSG); //  ,     
    if AErr=0 then PostMessage(Hand, WM_EditMSG, 5, ANumMSG); //  ,     
  end;
end;

procedure TfrmEditMsg.grdMSGKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin //   
  //if (key=VK_ESCAPE) and  tlbtnMoveRange.Enabled then RestoreAfterMoveRange;
  if (key=80) and FlagMoveRange then
  begin
    if ShowMoveRange(DLine) then //     
    begin
      grdMSG.Cursor := crDrag;
      stsbrMain.Panels[0].Text := ' ,       ';
    end
    else RestoreAfterMoveRange; //         ""
  end;
  if not(tlbrMain.Enabled) then Exit; //    ,    
  //if (key=VK_F2) and (tlbtnSaveMSG.Enabled) then
  //  tlbtnSaveMSGClick(Sender); //  F2 ()
  with grdMSG do
  begin
    if (key=VK_ESCAPE) and (EditorMode) and (AStrEsc<>'') then //  Esc
    begin
      EditorMode := False;
      Cells[Col, Row] := AStrEsc;
      //tlbtnSaveMSG.Enabled := False;
    end;
    //if (key=VK_DELETE) and not(EditorMode) then Cells[Col, Row] := '';
  end;
end;

procedure TfrmEditMsg.grdMSGGetEditText(Sender: TObject; ACol,
  ARow: Integer; var Value: String);
begin //      
  AStrEsc := Value;
end;

procedure TfrmEditMsg.grdMSGKeyPress(Sender: TObject; var Key: Char);
begin //  ASCII   
  if not(tlbrMain.Enabled) then Exit; //    ,    
  if not(PrgOpt.SetCod1C) then //   1
  begin
    if Key=#185 then Key:=#35;
    if Key='' then Key:='X'; //    ''  
  end;
  //if Key='' then Key:=''; //  ''   ''
  //if Key='' then Key:=''; //  ''   ''
  if (grdMSG.Col=0) and not(Key in ['0'..'9', '#', #8]) then Key := #0;
(*  if not(Key in [#13, #27]) then // #13 Enter, #27 Esc
  begin
    AModif := True;
    tlbtnSaveMSG.Enabled := AModif;
  end;   *)
end;

procedure TfrmEditMsg.itmHistoryClick(Sender: TObject);
var
  ATempName: string;
  AMnuItem: TMenuItem;
  i: Integer;
begin //       
  AMnuItem := TMenuItem(Sender);
  ATempName := AMnuItem.Caption;
  if not(FileExists(ATempName)) then AMnuItem.Free //    
  else
    if Izmenenia(Sender) then
      with pmnHistory do
      begin
        for i:=Items.IndexOf(AMnuItem) downto 1 do //   
          Items[i].Caption := Items[i-1].Caption;
        Items[0].Caption := ATempName;
        //GridMSGInitial; //     
        try
          LoadedMSG(ATempName);
          AFileName := ATempName;
          Caption := CNameProgr + ' - [' + ExtractFileName(AFileName) + ']';
          Application.Title := '[' + ExtractFileName(AFileName) + '] ' + AppName;
          tlbtnSaveMSG.Enabled := False;
        except
          ShowMessage(' :  [M]    .');
          frmEditMsg.Enabled := True; //  
          AFileName := CNameDefault; //    noname
        end;
        SaveHistoryToINI(pmnHistory);
      end;
end;

procedure TfrmEditMsg.AddNewMnuItemToBegin(const ANameProg: string; APopup: TPopupMenu);
var
  AMnuItem: TMenuItem;
  i: Integer;
begin //     ,  
  // ,      ,   ,     
  for i:=0 to APopup.Items.Count-1 do //ComponentCount-1//    
    if AnsiLowerCase(APopup.Items[i].Caption)=AnsiLowerCase(ANameProg) then
    begin
      APopup.Items[i].MenuIndex := 0; //   
      SaveHistoryToINI(pmnHistory);
      Exit;
    end;
  //      
  AMnuItem := TMenuItem.Create(APopup); // 
  APopup.Items.Add(AMnuItem); // 
  AMnuItem.Caption := ANameProg;
  AMnuItem.OnClick := itmHistoryClick; //  
  APopup.Items[APopup.Items.Count-1].MenuIndex := 0;  //   
  if APopup.Items.Count>ASizeMnuHistory then //   
    APopup.Items[APopup.Items.Count-1].Free; //  
  SaveHistoryToINI(pmnHistory);
end;

procedure TfrmEditMsg.spdbtnAboutClick(Sender: TObject);
begin //   " "
  ShowAboutBox;
end;

procedure TfrmEditMsg.tlbrMainResize(Sender: TObject);
begin //   " "
  with tlbtnSeparatorAbout do Width := tlbrMain.Width - Left - 25;
end;

procedure TfrmEditMsg.FormActivate(Sender: TObject);
begin //     
  //HandWndMsg := edtWndMsg
  AFileName := CNameDefault;
  Caption := CNameProgr + ' - [' + ExtractFileName(AFileName) + ']';
  Application.Title := '[' + ExtractFileName(AFileName) + '] ' + AppName;
  GridMSGInitial;
  ASelfPath := ExtractFilePath(Application.EXEName); //    
  LoadHistoryFromINI(pmnHistory); //  
  LoadPathsToINI; //   
  // ***       
  LoadFormStatFromINI;
  Left := StatEditMsg.Left;
  Top := StatEditMsg.Top;
  Width := StatEditMsg.Width;
  Height := StatEditMsg.Height;
  if StatEditMsg.Max then WindowState := wsMaximized;
  // ***
  LoadPrgOptFromINI; //   
  if not(InitCommandLine(Sender)) then  //   
  begin //    ,   
    if PrgOpt.RunLastFile and (pmnHistory.Items.Count>0) then
    begin //    
      if FileExists(pmnHistory.Items[0].Caption) then
      begin
        AFileName := pmnHistory.Items[0].Caption;
        try
          LoadedMSG(AFileName);
          Caption := CNameProgr + ' - [' + ExtractFileName(AFileName) + ']';
          Application.Title := '[' + ExtractFileName(AFileName) + '] ' + AppName;
          tlbtnSaveMSG.Enabled := False;
        except
          ShowMessage(' :       FormActivate.');
          frmEditMsg.Enabled := True; //  
          AFileName := CNameDefault; //    noname
        end;
      end;
    end;
  end;
  //Self.SendToBack; //  
end;

procedure TfrmEditMsg.tlbtnPrgOptClick(Sender: TObject);
begin //    
  ShowPrgOpt;
  SavePrgOptToINI; //    INI
end;

procedure TfrmEditMsg.tlbtnAddClearClick(Sender: TObject);
var i: Word;
begin //   ,   ,  , 
  tlbtnSaveMSG.Enabled := True;
  with grdMSG do
  begin
    RowCount := RowCount + 1;
    for i:=RowCount-1 downto Row do Rows[i] := Rows[i-1];
    Rows[Row].Clear;
  end;
end;

procedure TfrmEditMsg.grdMSGSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin //      
  if AStrEsc<>Value then tlbtnSaveMSG.Enabled := True;
end;

procedure TfrmEditMsg.edtWndMsgChange(Sender: TObject);
var ATmpName: string;
begin //   ,    . msg-
  if tlbtnSaveMSG.Enabled then Exit; //    
  if tlbtnMoveRange.Down then Exit; //     
  if not(PrgOpt.RunScriptMsg) then Exit;
  grdMSG.SetFocus;
  if not grdMSG.Focused then Exit;
  //if not grdMSG.CanFocus then Exit;
  ATmpName := FindMsgInPath(edtWndMsg.Text);
  if (ATmpName='') or not(FileExists(ATmpName)) then Exit;

  //if Izmenenia(Sender) then

  AFileName := ATmpName;
  try
    LoadedMSG(AFileName);
    AddNewMnuItemToBegin(AFileName, pmnHistory);
    tlbtnSaveMSG.Enabled := False;
    Caption := CNameProgr + ' - [' + ExtractFileName(AFileName) + ']';
    Application.Title := '[' + ExtractFileName(AFileName) + '] ' + AppName;
  except
    ShowMessage(' :       edtWndMsgChange.'+CR+
                'FileName='+AFileName);
    frmEditMsg.Enabled := True; //  
    AFileName := CNameDefault; //    noname
  end;
end;

function TfrmEditMsg.FindMsgInPath(const AName: String): String;
var
  APath: String;
  i: Integer;
begin //     ,  ,   
  Result := '';
  for i:=0 to Length(PrgOpt.MsgPath)-1 do
  begin
    APath := PrgOpt.MsgPath[i] + ChangeFileExt(AName, '.msg');
    if FileExists(APath) then
    begin
      Result := APath;
      Break;
    end;
  end;
end;

procedure TfrmEditMsg.stsbrMainMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin //         
  stsbrMain.Panels[0].Text := AFileName;
end;

procedure TfrmEditMsg.tmrMainPanelTimer(Sender: TObject);
begin //     
  if WindowState=wsNormal then
  begin
    StatEditMsg.Max := False;
    StatEditMsg.Left := Left;
    StatEditMsg.Top := Top;
    StatEditMsg.Width := Width;
    StatEditMsg.Height := Height;
  end
  else StatEditMsg.Max := True;
end;

procedure TfrmEditMsg.tlbtnGoBeginClick(Sender: TObject);
begin //   
  grdMSG.Col := 0;
  grdMSG.Row := 1;
  edtFind.SetFocus;
end;

procedure TfrmEditMsg.tlbtnGoEndClick(Sender: TObject);
begin //   
  grdMSG.Col := 0;
  grdMSG.Row := grdMSG.RowCount - 1;
  edtFind.SetFocus;
end;

procedure TfrmEditMsg.tlbtnFindDownClick(Sender: TObject);
begin //     
  grdMSG.EditorMode := False;
  if edtFind.Text='' then Exit;
  if not(FindTextInMSG(edtFind.Text, True)) then
    if MessageBox(Self.Handle,
         PChar(' .    ?'),
         PChar(' '), MB_ICONWARNING + MB_YESNO) = 6 then
      tlbtnGoBeginClick(Sender);
end;

procedure TfrmEditMsg.tlbtnFindUpClick(Sender: TObject);
begin //     
  grdMSG.EditorMode := False;
  if edtFind.Text='' then Exit;
  if not(FindTextInMSG(edtFind.Text, False)) then
    if MessageBox(Self.Handle,
         PChar(' .    ?'),
         PChar(' '), MB_ICONWARNING + MB_YESNO) = 6 then
      tlbtnGoEndClick(Sender);
end;

function TfrmEditMsg.FindTextInMSG(const AStr: string; ToDown: Boolean): Boolean;
var cl, rw: Integer;
begin //      ,  True,   AStr 
      // ToDown=True   
  Result := False;
  //if AStr='' then Exit;
  with grdMSG do
  begin
    cl := 0;
    rw := 1;
    if ToDown then //   
    begin
      rw := Row;
      cl := Col + 1;
      if cl>3 then
      begin
        cl := 0;
        rw := rw + 1;
      end;
    end;
    if not(ToDown) then //   
    begin
      rw := Row;
      cl := Col - 1;
      if cl<0 then
      begin
        cl := 3;
        rw := rw - 1;
      end;
    end;
    while (rw<RowCount) and (rw>0) do
    begin
      while (cl<=3) and (cl>=0) do
      begin
        if Pos(AnsiLowerCase(AStr), AnsiLowerCase(Cells[cl, rw]))<>0 then
        begin
          //SetFocus;
          edtFind.SetFocus;
          Row := rw;
          Col := cl;
          Result := True;
          Exit;
        end;
        //stsbrLstEditor.Panels[0].Text := AnsiLowerCase(Cells[cl, rw]);
        //ShowMessage('Stop');
        if ToDown then cl := cl + 1 //   
        else cl := cl - 1; //   
      end;
      if ToDown then //   
      begin
        rw := rw + 1;
        cl := 0;
      end
      else //   
      begin
        rw := rw - 1;
        cl := 3;
      end;
    end;
  end;
end;

procedure TfrmEditMsg.grdMSGMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i: Integer;
begin //   
  if Button=mbLeft then //     
  begin
    if tlbtnMoveRange.Down and not(FlagMoveRange) then
    begin //     
      FlagMoveRange := True;
      mr := grdMSG.Selection; // Top -  , Bottom - 
      i := mr.Top;
      while(i<=mr.Bottom) and (GetIntFromStr(grdMSG.Cells[0, i])=0) do Inc(i);
      if i<=mr.Bottom then DLine.Old := GetIntFromStr(grdMSG.Cells[0, i]) else
        DLine.Old := 0;
      DLine.New := DLine.Old;
      grdMSG.Cursor := crDrag;
      stsbrMain.Panels[0].Text := ' ,       ,   [P]   ';
    end;
  end;
  (*
  if Button=mbLeft then //     
  begin
    if tlbtnMoveRange.Down and not(FlagMoveRange) then
    begin //     
      FlagMoveRange := True;
      mr := grdMSG.Selection; // Top -  , Bottom - 
      i := mr.Top;
      while(i<=mr.Bottom) and (GetIntFromStr(grdMSG.Cells[0, i])=0) do Inc(i);
      if i<=mr.Bottom then DLine.Old := GetIntFromStr(grdMSG.Cells[0, i]) else
        DLine.Old := 0;
      if ShowMoveRange(DLine) then //     
      begin
        grdMSG.Cursor := crDrag;
        stsbrMain.Panels[0].Text := ' ,       ';
      end
      else RestoreAfterMoveRange; //         ""
    end;
  end;
*)
end;

procedure TfrmEditMsg.RestoreAfterMoveRange;
begin //      
  FlagMoveRange := False;
  grdMSG.Cursor := crDefault;
  grdMSG.Options := grdMSG.Options - [goRowSelect, goRangeSelect] + [goEditing];
  tlbtnMoveRange.Down := False;
  tlbrMain.Enabled := True;
  grdMSG.Col := 2; //     ,   
  stsbrMain.Panels[0].Text := '';
end;

procedure TfrmEditMsg.tlbtnMoveRangeClick(Sender: TObject);
begin //     
  //spnedtMoveRange.Color := clWindow;
  //spnedtMoveRange.Enabled := tlbtnMoveRange.Down;
  if tlbtnMoveRange.Down then
  begin
    tlbrMain.Enabled := False;
    grdMSG.Cursor := crHandPoint; //   
    grdMSG.Options := grdMSG.Options - [goEditing] + [goRowSelect, goRangeSelect];
  end;

end;

procedure TfrmEditMsg.grdMSGMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin //    
  if (Button=mbLeft) and FlagMoveRange then
  begin //     
    tlbtnSaveMSG.Enabled := True;
    ReNomerationMSG(mr.Top, mr.Bottom, DLine.New - DLine.Old); //   
    MoveGridRange(grdMSG, mr.Top, mr.Bottom, grdMSG.Selection.Top); //   
    RestoreAfterMoveRange;
  end;
  //if (Button=mbRight) and FlagMoveRange then RestoreAfterMoveRange;
  if (Button=mbRight) and tlbtnMoveRange.Down then RestoreAfterMoveRange;
end;

procedure TfrmEditMsg.ReNomerationMSG(const ATop, ABottom, AInc: Integer);
var i: Integer;
begin //   
  with grdMSG do
    for i:= ATop to ABottom do
      if GetIntFromStr(Cells[0, i])<>0 then
        Cells[0, i] := IntToStr(GetIntFromStr(Cells[0, i])+ AInc);
end;

procedure TfrmEditMsg.MoveGridRange(AGrid: TStringGrid;
  ATop, ABottom, ANewTop: Integer);
var
  t0, t1, t2: array of string;
  i, YLen: Integer;
begin //       
  with AGrid do
  begin
    if (ATop<=ANewTop) and (ABottom>=ANewTop) then //     
    begin
      if DLine.ToEnd then //         
        ReNomerationMSG(ABottom+1, grdMSG.RowCount-1, DLine.New - DLine.Old);
      Exit;
    end;
    if ABottom = RowCount-1 then Dec(ABottom); //     () 
    YLen := ABottom - ATop;
    SetLength(t0, YLen+1);
    SetLength(t1, YLen+1);
    SetLength(t2, YLen+1);
    for i:=0 to YLen do //   
    begin
      t0[i] := Cells[0, ATop+i];
      t1[i] := Cells[1, ATop+i];
      t2[i] := Cells[2, ATop+i];
    end;
    if ANewTop-ABottom-1>=0 then
    begin //    
      for i:=0 to ANewTop-ABottom-1 do //    
        Rows[ATop+i] := Rows[ABottom+i+1];
      for i:=0 to YLen do //      
      begin
        Cells[0, ANewTop-YLen+i-1] := t0[i];
        Cells[1, ANewTop-YLen+i-1] := t1[i];
        Cells[2, ANewTop-YLen+i-1] := t2[i];
      end;
      if DLine.ToEnd then //         
        ReNomerationMSG(ANewTop, grdMSG.RowCount-1, DLine.New - DLine.Old);
    end
    else //    
    begin
      for i:=0 to ATop-ANewTop-1 do //    
        Rows[ABottom-i] := Rows[ATop-i-1];
      for i:=0 to YLen do //      
      begin
        Cells[0, ANewTop+i] := t0[i];
        Cells[1, ANewTop+i] := t1[i];
        Cells[2, ANewTop+i] := t2[i];
      end;
      if DLine.ToEnd then //         
        ReNomerationMSG(ANewTop+(ABottom-ATop)+1, grdMSG.RowCount-1, DLine.Old - DLine.New);
    end;
  end;
end;

end.
