unit WorkINI;

interface

uses SysUtils, IniFiles, Forms, Menus, Graphics, ShellAPI;

  procedure LoadFormStatFromINI;
  procedure SaveFormStatToINI;
  procedure SavePathsToINI;
  procedure LoadPathsToINI;
  procedure LoadHistoryFromINI(APopup: TPopupMenu);
  procedure SaveHistoryToINI(APopup: TPopupMenu);
  procedure SavePrgOptToINI;
  procedure LoadPrgOptFromINI;

const ININame = 'EditorMSG.ini';

implementation

uses EditMSG;

procedure SaveFormStatToINI;
var
  ATempINI: TIniFile;
begin //     INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    //   frmEditMsg
    ATempINI.WriteBool('EditMsgPos', 'StatMax', StatEditMsg.Max);
    ATempINI.WriteInteger('EditMsgPos', 'Left', StatEditMsg.Left);
    ATempINI.WriteInteger('EditMsgPos', 'Top', StatEditMsg.Top);
    ATempINI.WriteInteger('EditMsgPos', 'Width', StatEditMsg.Width);
    ATempINI.WriteInteger('EditMsgPos', 'Height', StatEditMsg.Height);
  finally
    ATempINI.Free;
  end;
end;

procedure LoadFormStatFromINI;
var
  ATempINI: TIniFile;
begin //     INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    //   frmEditMsg
    StatEditMsg.Max := ATempINI.ReadBool('EditMsgPos', 'StatMax', False);
    StatEditMsg.Left := ATempINI.ReadInteger('EditMsgPos', 'Left', 2);
    StatEditMsg.Top := ATempINI.ReadInteger('EditMsgPos', 'Top', 2);
    StatEditMsg.Width := ATempINI.ReadInteger('EditMsgPos', 'Width', 795);
    StatEditMsg.Height := ATempINI.ReadInteger('EditMsgPos', 'Height', 420);
  finally
    ATempINI.Free;
  end;
end;

procedure SavePathsToINI;
var
  ATempINI: TIniFile;
begin //      INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    ATempINI.WriteString('Paths', 'OpenMSG', frmEditMsg.opndlgOpenMSG.InitialDir);
    ATempINI.WriteString('Paths', 'SaveMSG', frmEditMsg.svdlgSaveMSG.InitialDir);
  finally
    ATempINI.Free;
  end;
end;

procedure LoadPathsToINI;
var
  ATempINI: TIniFile;
begin //      INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    frmEditMsg.opndlgOpenMSG.InitialDir := ATempINI.ReadString('Paths', 'OpenMSG', '');
    frmEditMsg.svdlgSaveMSG.InitialDir := ATempINI.ReadString('Paths', 'SaveMSG', '');
  finally
    ATempINI.Free;
  end;
end;

procedure LoadHistoryFromINI(APopup: TPopupMenu);
var
  ATempINI: TIniFile;
  AMnuItem: TMenuItem;
  i: byte;
  ANameProg: string;
begin //      INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    i := 1;
    repeat
      ANameProg := ATempINI.ReadString('History', 'h'+IntToStr(i), '');
      if ANameProg<>'' then //    
        if FileExists(ANameProg) then
        begin
          AMnuItem := TMenuItem.Create(APopup);
          APopup.Items.Add(AMnuItem);
          AMnuItem.Caption := ANameProg;
          AMnuItem.OnClick := frmEditMsg.itmHistoryClick; //  
        end;
      i := i + 1;
    until (i>ASizeMnuHistory);// or (ANameProg=''); //   .
      //SaveAllProgToINI(ActPr, frmMain.pmnProgStart);
  finally
    ATempINI.Free;
  end;
end;

procedure SaveHistoryToINI(APopup: TPopupMenu);
var
  ATempINI: TIniFile;
  i: Word;
begin //       INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    for i:=0 to ASizeMnuHistory-1 do
      if i<APopup.Items.Count then
        ATempINI.WriteString('History', 'h'+IntToStr(i+1), APopup.Items[i].Caption)
      else ATempINI.WriteString('History', 'h'+IntToStr(i+1), '');
  finally
    ATempINI.Free;
  end;
end;

procedure SavePrgOptToINI;
var
  ATempINI: TIniFile;
  i: Byte;
begin //    INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    ATempINI.WriteBool('ProgOptions', 'RunLastFile', PrgOpt.RunLastFile);
    ATempINI.WriteInteger('EditMsgPos', 'AddNumComm', PrgOpt.AddNumComm);
    ATempINI.WriteBool('ProgOptions', 'RunScriptMsg', PrgOpt.RunScriptMsg);
    ATempINI.WriteInteger('ColSize', 'Num', frmEditMsg.grdMSG.ColWidths[0]);
    ATempINI.WriteInteger('ColSize', 'Head', frmEditMsg.grdMSG.ColWidths[1]);
    ATempINI.WriteInteger('ColSize', 'Comment', frmEditMsg.grdMSG.ColWidths[2]);
    for i:=0 to SizeMsgPath-1 do
      if i<Length(PrgOpt.MsgPath) then
        ATempINI.WriteString('MsgPath', 'p'+IntToStr(i+1), PrgOpt.MsgPath[i])
      else ATempINI.WriteString('MsgPath', 'p'+IntToStr(i+1), '');
    ATempINI.WriteBool('ProgOptions', 'SetCod1C', PrgOpt.SetCod1C);
  finally
    ATempINI.Free;
  end;
end;

procedure LoadPrgOptFromINI;
var
  ATempINI: TIniFile;
  i: byte;
  APath: string;
begin //    INI
  ATempINI := TIniFile.Create(ASelfPath + ININame);
  try
    PrgOpt.RunLastFile := ATempINI.ReadBool('ProgOptions', 'RunLastFile', True);
    PrgOpt.AddNumComm := ATempINI.ReadInteger('EditMsgPos', 'AddNumComm', 10);
    PrgOpt.RunScriptMsg := ATempINI.ReadBool('ProgOptions', 'RunScriptMsg', True);
    frmEditMsg.grdMSG.ColWidths[0] := ATempINI.ReadInteger('ColSize', 'Num', 42);
    frmEditMsg.grdMSG.ColWidths[1] := ATempINI.ReadInteger('ColSize', 'Head', 53);
    frmEditMsg.grdMSG.ColWidths[2] := ATempINI.ReadInteger('ColSize', 'Comment', 681);
    i := 1;
    repeat
      APath := ATempINI.ReadString('MsgPath', 'p'+IntToStr(i), '');
      if APath<>'' then
      begin
        SetLength(PrgOpt.MsgPath, i);
        PrgOpt.MsgPath[i-1] := APath;
      end;
      i := i + 1;
    until (i>SizeMsgPath);
    PrgOpt.SetCod1C := ATempINI.ReadBool('ProgOptions', 'SetCod1C', False);
  finally
    ATempINI.Free;
  end;
end;


end.
