unit untDlgEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ToolWin, Grids, StdCtrls, ImgList, SynMemo;

type
  TfrmDlgEditor = class(TForm)
    tlbrDlgEdit: TToolBar;
    tlbtnReturn: TToolButton;
    grdForMSG: TStringGrid;
    edtForMSG1: TEdit;
    tlbtnDlgNavBack: TToolButton;
    imglstBtnDialog: TImageList;
    tlbtnDlgNavForward: TToolButton;
    tlbtnDESeparator1: TToolButton;
    procedure tlbtnReturnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure edtForMSG1Change(Sender: TObject);
    procedure tlbtnDlgNavBackClick(Sender: TObject);
    procedure grdForMSGDblClick(Sender: TObject);
    procedure grdForMSGMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure tlbtnDlgNavForwardClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AppActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure grdForMSGClick(Sender: TObject);
    procedure grdForMSGKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    procedure ScriptScaner(Sender: TObject);
    procedure PasteNumInGrid(const ANum: Integer; const AMes: string);
    function GetArgument(const AStr: string; const ANum: Integer): string;
    procedure AddStrToGrid(Tek: Integer);
    procedure GridDlgMSGInitial;
    //procedure RefreshMsgTxt;
    { Private declarations }
  public
    { Public declarations }
  end;

procedure ShowDlgEditor;

var
  frmDlgEditor: TfrmDlgEditor;
  FlagDlgEditor: Boolean; //    
  xc, yc: Integer; //    

implementation

uses untMain, MathPNO;

{$R *.DFM}

procedure ShowDlgEditor;
begin
  with TfrmDlgEditor.Create(Application) do
    try
      FlagDlgEditor := True;
      ShowModal;
    finally
      Free;
      FlagDlgEditor := False;
    end;
end;

procedure TfrmDlgEditor.tlbtnReturnClick(Sender: TObject);
begin //      
  ModalResult := mrCancel;
end;

procedure TfrmDlgEditor.FormShow(Sender: TObject);
begin //     
  GridDlgMSGInitial;
  with grdForMSG do
  begin
    if MiscOpt.AProc>=75 then ColWidths[1]:=MiscOpt.AProc else ColWidths[1]:=75;
    if MiscOpt.ANum >=40 then ColWidths[2]:=MiscOpt.ANum else ColWidths[2]:=40;
    if MiscOpt.AMsg>=550 then ColWidths[3]:=MiscOpt.AMsg else ColWidths[3]:=550;
  end;
  ScriptScaner(Sender);
  with frmMain do
  begin
    tlbtnDlgNavBack.Enabled := tlbtnBack.Enabled;
    tlbtnDlgNavForward.Enabled := tlbtnForward.Enabled;
  end;
end;

procedure TfrmDlgEditor.ScriptScaner(Sender: TObject);
var
  i, APos, NMess, Err, NumArg, ATmp: Integer;
  tz, ArgStr: string;
  CommFlg: Boolean; //    
begin //       
  CommFlg := False;
  with grdForMSG do
    for i:=0 to frmMain.ActiveMemo.Lines.Count-1 do
    begin
      NumArg := 0;
      tz := frmMain.ActiveMemo.Lines[i];
      if tz='' then Continue; //    
      //   
      ATmp := Pos('//', tz);
      if (ATmp<>0) and (Trim(Copy(tz, 1, ATmp+1))='//') then Continue;
      ATmp := Pos('/*', tz);
      if (ATmp<>0) and (Trim(Copy(tz, 1, ATmp+1))='/*') then CommFlg:=True;
      if CommFlg then //  "/*"
      begin
        ATmp := Pos('*/', tz);
        if ATmp<>0 then //    
        begin
          CommFlg:=False; //     
          if Trim(Copy(tz, 1, ATmp+1))<>'*/' then Continue; //   
        end else Continue;
      end;
      //  
      APos := Pos('gsay_reply', AnsiLowerCase(tz));
      if APos>0 then NumArg := 2 //   gsay_reply
      else
      begin
        APos := Pos('reply', AnsiLowerCase(tz));
        if APos>0 then NumArg := 1 //   reply
      end;
      if NumArg<>0 then //    
      begin
        Cells[0, RowCount-1] := '**';
        ArgStr := GetArgument(Copy(tz, APos, Length(tz)-APos), NumArg); //   
        Val(ArgStr, NMess, Err); //   
        if NMess>0 then
        begin
          Cells[2, RowCount-1] := IntToStr(NMess);
          frmMain.SendToEditMSG(NMess, edtForMSG1.Handle);
        end
        else Cells[2, RowCount-1] := '?';
        RowCount := RowCount + 1;
        Continue;
      end;
      //  
      APos := Pos('giq_option', AnsiLowerCase(tz));
      if APos>0 then NumArg := 3 //   gsay_reply
      else begin
        APos := Pos('goption', AnsiLowerCase(tz));
        if APos>0 then NumArg := 1 //   goption
        else begin
          APos := Pos('noption', AnsiLowerCase(tz));
          if APos>0 then NumArg := 1 //   noption
          else begin
            APos := Pos('boption', AnsiLowerCase(tz));
            if APos>0 then NumArg := 1 //   boption
            else begin
              APos := Pos('nlowoption', AnsiLowerCase(tz));
              if APos>0 then NumArg := 1 //   boption
            end;
          end;
        end;
      end;
      if NumArg<>0 then //    
      begin
        Cells[0, RowCount-1] := '->';
        ArgStr := GetArgument(Copy(tz, APos, Length(tz)-APos+1), NumArg); //   
        Val(ArgStr, NMess, Err); //   
        if NMess>0 then
        begin
          Cells[2, RowCount-1] := IntToStr(NMess);
          Cells[1, RowCount-1] := GetArgument(tz, NumArg+1); //   
          frmMain.SendToEditMSG(NMess, edtForMSG1.Handle);
        end
        else Cells[2, RowCount-1] := '?';
        RowCount := RowCount + 1;
        Continue;
      end;
    end;
end;

function TfrmDlgEditor.GetArgument(const AStr: string; const ANum: Integer): string;
var
  BPos, EPos, Arg: Integer;
begin //     , ,  
  Result := '';
  Arg := 1;
  BPos := PosTf('(', AStr, 1); //   
  if BPos<1 then Exit;
  repeat
    EPos := PosTf(',', AStr, BPos+1);
    if EPos>0 then //   
    begin
      if Arg = ANum then
      begin
        Result := Trim(Copy(AStr, BPos+1, EPos-BPos-1));
        Exit;
      end;
      BPos := EPos;
      Arg := Arg + 1;
    end;
  until (EPos<1) or (Arg>ANum); //  
  EPos := PosTf(')', AStr, 1); //   
  if EPos<1 then Exit;
  if Arg = ANum then Result := Trim(Copy(AStr, BPos+1, EPos-BPos-1));
end;

procedure TfrmDlgEditor.PasteNumInGrid(const ANum: Integer; const AMes: string);
var i, pcr1, pcr2: Integer;
begin //       
  i := 0;
  with grdForMSG do
  begin
    //for i:=0 to RowCount-1 do
    while i<RowCount do
    begin
      pcr1 := 1;
      if GetIntFromStr(Cells[2, i])=ANum then
      begin
        pcr2 := PosTf('<cr>', AMes, 1); //    
        if pcr2<1 then //      
        begin
          Cells[3, i] := AMes; //      
          i := i + 1;
          Continue;
        end;
        //    
        repeat
          Cells[3, i] := Copy(AMes, pcr1, pcr2-pcr1);
          pcr1 := pcr2 + 4; //    <cr>
          pcr2 := PosTf('<cr>', AMes, pcr1); //    
          i := i + 1;
          AddStrToGrid(i); //     i,   
        until pcr2<1;
        Cells[3, i] := Copy(AMes, pcr1, Length(AMes)-pcr1+1);
      end;
      i := i + 1;
    end;
  end;
end;

procedure TfrmDlgEditor.AddStrToGrid(Tek: Integer);
var i: Word;
begin //     
  //AModif := True;
  //tlbtnSaveMSG.Enabled := AModif;
  with grdForMSG do
  begin
    RowCount := RowCount + 1;
    for i:=RowCount-1 downto Tek do Rows[i] := Rows[i-1];
    Rows[Tek].Clear;
  end;
end;

procedure TfrmDlgEditor.edtForMSG1Change(Sender: TObject);
var
  Mes: Integer; //  
  Str: string; //  
begin //      
  Mes := GetNumFromMSG(edtForMSG1.Text);
  Str := GetStrFromMSG(edtForMSG1.Text);
  PasteNumInGrid(Mes, Str);
end;

function EnumProc(Wd: HWnd; Param: LongInt): Boolean; stdcall;//  stdcall !!!
var
  Nm: array[0..255] of Char;  //    
  Cs: Array[0..255] of Char; //   
begin //     
  Hand := 0;
  GetWindowText(Wd, Nm, 255); //     
  GetClassName(Wd, Cs, 255); //    
  if (Pos(NameEditorMSG, String(Nm))<>0) and (String(Cs)='TfrmEditMsg') then
  begin
    EnumProc := False;
    Hand := Wd;
  end
  else EnumProc := True;
end;

procedure TfrmDlgEditor.grdForMSGDblClick(Sender: TObject);
var
  ACol, ARow, i: Integer;
  PrName: string;
  ANum: Integer;
begin
  with grdForMSG do
  begin
    MouseToCell(xc, yc, ACol, ARow);
    if (ACol=-1) or (ARow=-1) then Exit; //    
    if (ACol=2) or (ACol=3) then //       
    begin
      EditorMode := False;
      EnumWindows(@EnumProc, 0); //   msg-  
      if (Hand<>0) then //    
      begin
        SetForeGroundWindow(Hand); //      
        if Cells[2, Row]<>'' then
        begin
          ANum := GetIntFromStr(Cells[2, Row]);
          if ANum>0 then SendMessage(Hand, WM_EditMSG, 4, ANum) //    
        end
        else if Cells[3, Row]='' then SendMessage(Hand, WM_EditMSG, 4, 0) //   
      end;
      Exit;
    end;
    //    
    PrName := Cells[1, ARow]; //   
    if PrName='' then Exit; //    
    with frmMain do
    begin
      i := GetPageAtNameProc(PrName);
      if i>0 then
        with ActiveMemo do
        begin
          //  
          NormCurAndCol;//(Sender);  //      
          if GetActiveIndex<>i then
          begin
            //pgcntrlMain.ActivePage := pgcntrlMain.Pages[i]; //   
            SetActiveMemo(i); //   
            //NavigatorControl; //  
            //    
            GridDlgMSGInitial;
            tlbtnDlgNavBack.Enabled := tlbtnBack.Enabled;
            tlbtnDlgNavForward.Enabled := tlbtnForward.Enabled;
            ScriptScaner(Sender);
          end;
        end;
    end;
  end;
end;

procedure TfrmDlgEditor.GridDlgMSGInitial;
begin //   
  grdForMSG.EditorMode := False;
  grdForMSG.SetFocus;
  grdForMSG.Cols[0].Clear;
  grdForMSG.Cols[1].Clear;
  grdForMSG.Cols[2].Clear;
  grdForMSG.Cols[3].Clear;
  grdForMSG.RowCount := 2;
  grdForMSG.Cells[1,0] := '';
  grdForMSG.Cells[2,0] := '';
  grdForMSG.Cells[3,0] := ' ';
end;

procedure TfrmDlgEditor.grdForMSGMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin //   
  xc := X;
  yc := Y;
end;

procedure TfrmDlgEditor.tlbtnDlgNavForwardClick(Sender: TObject);
begin //   ""
  frmMain.NormCurAndCol;//(Sender);  //      
  frmMain.tlbtnForwardClick(Sender); //    ""
  tlbtnDlgNavBack.Enabled := frmMain.tlbtnBack.Enabled;
  tlbtnDlgNavForward.Enabled := frmMain.tlbtnForward.Enabled;
  GridDlgMSGInitial;
  ScriptScaner(Sender);
end;

procedure TfrmDlgEditor.tlbtnDlgNavBackClick(Sender: TObject);
begin //   ""
  frmMain.NormCurAndCol;//(Sender);  //      
  frmMain.tlbtnBackClick(Sender); //    ""
  tlbtnDlgNavBack.Enabled := frmMain.tlbtnBack.Enabled;
  tlbtnDlgNavForward.Enabled := frmMain.tlbtnForward.Enabled;
  GridDlgMSGInitial;
  ScriptScaner(Sender);
end;

procedure TfrmDlgEditor.FormCreate(Sender: TObject);
begin
  Application.OnActivate := AppActivate;
  Left := StatDlgEdit.Left;
  Top := StatDlgEdit.Top;
  Width := StatDlgEdit.Width;
  Height := StatDlgEdit.Height;
  if StatDlgEdit.Max then WindowState := wsMaximized;
end;

procedure TfrmDlgEditor.AppActivate(Sender: TObject);
begin //   ,    
  if DlgAct then
  begin
    GridDlgMSGInitial;
    ScriptScaner(Sender);
  end;
end;

procedure TfrmDlgEditor.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin //      
  if WindowState = wsMaximized then StatDlgEdit.Max := True
  else
  begin
    StatDlgEdit.Max := False;
    StatDlgEdit.Left := Left;
    StatDlgEdit.Top := Top;
    StatDlgEdit.Width := Width;
    StatDlgEdit.Height := Height;
  end;
  //   
  MiscOpt.AProc := grdForMSG.ColWidths[1];
  MiscOpt.ANum := grdForMSG.ColWidths[2];
  MiscOpt.AMsg := grdForMSG.ColWidths[3];
end;

procedure TfrmDlgEditor.grdForMSGClick(Sender: TObject);
begin
  with grdForMSG do
    if Col<>1 then EditorMode := False;
end;

procedure TfrmDlgEditor.grdForMSGKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key=VK_ESCAPE then // Esc
    ModalResult := mrCancel;
end;

end.
